--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Bit random initialise component
--
-- Author  Matthew Caryl
-- Created 16.1.97
--

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Random;
with Mutants.Core.Individual;
with Mutants.Core.Representation.Bit;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Selector;
use Mutants.Core.Population;
use Mutants.Core.Random;
use Mutants.Core.Individual;
use Mutants.Core.Representation.Bit;

package body Mutants.Core.Creator.Bit_Random_Initialise is

	procedure Free is new Ada.Unchecked_Deallocation(Bit_Representation, Bit_Representation_Access);

	procedure Create(Creator : in out Bit_Random_Initialise; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		b : Bit_Representation_Access;
	begin
		b := new Bit_Representation;
		for j in 1..Size loop
			Set(b, Value(Creator.Chance));
			i := new Mutants.Core.Individual.Individual(Representation_Access(b));
			Add(Pop, i);
		end loop;
		Free(b);
	end Create;
	
	procedure Selector(Creator : in out Bit_Random_Initialise; Sel : Selector_Access; Required : out Boolean) is
	begin
		Required := false;
	end Selector;
	
	
	function Parents(Creator : in Bit_Random_Initialise) return Natural is
	begin
		return 0;
	end Parents;
	
	procedure Breed(Creator : in out Bit_Random_Initialise; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		b : Bit_Representation_Access;
	begin
		b := new Bit_Representation;
		Set(b, Value(Creator.Chance));
		Rep_Out := Representation_Access(b);
		Success := true;
	end Breed;
	
end Mutants.Core.Creator.Bit_Random_Initialise;
