--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Single vector mutation reproduction component
--
-- Author  Matthew Caryl
-- Created 22.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Vector;
with Mutants.Core.Random;
with Mutants.Core.Individual;
with Ada.Unchecked_Deallocation;
use Mutants.Core.Selector;
use Mutants.Core.Population;
use Mutants.Core.Individual;
use Mutants.Core.Random;

package body Mutants.Core.Creator.Single_Vector_Reproduction is
	
	use Vector_Package;
	procedure Free is new Ada.Unchecked_Deallocation(Vector_Representation, Vector_Representation_Access);
	
	use Vector_Package;
	procedure Create(Creator : in out Single_Vector_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural) is
		i : Individual_Access;
		r : Representation_Access;
		e : Element_Type_Access;
		v : Vector_Representation_Access;
		ps : array(Integer range 1..Parents(Creator)) of Vector_Representation_Access;
		rs : Representation_Access_Array(1..Parents(Creator));
		p : Natural;
		s : Natural;
		success : Boolean;
	begin
		-- make required number of individuals
		for j in 1..Size loop
			-- select requisit parents
			for k in 1..Parents(Creator) loop
				Get(Creator.Selector.all, i);
				ps(k) := Vector_Representation_Access(Mutants.Core.Individual.Representation(i));
			end loop;
			-- random position
			s := Vector_Package.Size(ps(1));
			p := Value(Creator.Chance, s) + 1;
			-- isolate element from parents vector
			for k in 1..Parents(Creator) loop
				Get(ps(k), p, e);
				rs(k) := Representation_Access(e);
			end loop;
			-- create new element
			Breed(Creator.Reproduction.all, rs, r, success);
			-- construct representation
			v := new Vector_Representation(s);
			for k in 1..(p - 1) loop
				Set(v, k, Get(ps(1), k));
			end loop;
			Set(v, p, Element_Type_Access(r).all);
			for k in (p + 1)..s loop
				Set(v, k, Get(ps(1), k));
			end loop;
			-- construct individual
			i := new Mutants.Core.Individual.Individual(Representation_Access(v));
			Add(Pop, i);
			Free(v);
		end loop;
	end Create;

	procedure Selector(Creator : in out Single_Vector_Reproduction; Sel : Selector_Access; Required : out Boolean) is
	begin
		Creator.Selector := Sel;
		Required := true;
	end Selector;
	
	function Parents(Creator : in Single_Vector_Reproduction) return Natural is
	begin
		return Parents(Creator.Reproduction.all);
	end Parents;

	use Vector_Package;
	procedure Breed(Creator : in out Single_Vector_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean) is
		v : Vector_Representation_Access;
		s : Natural := Size(Vector_Representation_Access(Reps_In(1)));
		e : Element_Type_Access;
		re : Representation_Access;
		r : Natural := Value(Creator.Chance, s) + 1;
		b : Representation_Access_Array(1..Parents(Creator));
	begin
		-- select requisit parents
		for i in 1..Parents(Creator) loop
			Get(v, r, e);
			b(i) := Representation_Access(e);
		end loop;
		-- create new element
		Breed(Creator.Reproduction.all, b, re, Success);
		-- construct representation
		v := new Vector_Representation(s);
		for i in 1..(r - 1) loop
			Set(v, i, Element_Type(Reps_In(i).all));
		end loop;
		Set(v, r, Element_Type(re.all));
		for i in (r + 1).. s loop
			Set(v, i, Element_Type(Reps_In(i).all));
		end loop;
		Rep_Out := Representation_Access(v);
	end Breed;

end Mutants.Core.Creator.Single_Vector_Reproduction;
