--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Single vector mutation reproduction component
--
-- Author  Matthew Caryl
-- Created 22.1.97
--
-- Unfinished - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Vector;
with Mutants.Core.Random;

use Mutants.Core.Selector;
use Mutants.Core.Representation;
use Mutants.Core.Random;

generic
	with package Vector_Package is new Mutants.Core.Representation.Vector(<>);

package Mutants.Core.Creator.Single_Vector_Reproduction is

	type Single_Vector_Reproduction(Rep : Creator_Access; Random : Random_Access) is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Single_Vector_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Single_Vector_Reproduction; Sel : Selector_Access; Required : out Boolean);
	
private
	
	type Single_Vector_Reproduction(Rep : Creator_Access; Random : Random_Access) is new Mutants.Core.Creator.Creator with
		record
			Reproduction : Creator_Access := Rep;
			Selector : Selector_Access;
			Chance : Random_Access := Random;
		end record;
			
	function Parents(Creator : in Single_Vector_Reproduction) return Natural;
	procedure Breed(Creator : in out Single_Vector_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Core.Creator.Single_Vector_Reproduction;
