--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Ending component
--
-- Author  Matthew Caryl
-- Created 12.12.96
--

with Ada.Calendar;
use Ada.Calendar;

package body Mutants.Core.Ending.Time is

	-- Error if they keep calling ending after it starts reporting false
	procedure Done(Ending : in out Time_Ending; Done : out Boolean) is
	begin
		Done := Ending.Finish_Time <= Clock;
	end Done;

	procedure Reset(Ending : in out Time_Ending; Period : Duration) is
	begin
		Ending.Finish_Time := Clock + Period;
	end Reset;

end Mutants.Core.Ending.Time;
