--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Binary Bit Vector Evaluation component
--
-- Author  Matthew Caryl
-- Created 13.12.96
--

with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation.Bit_Vector;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation.Bit_Vector;

package body Mutants.Core.Evaluation.Binary_Bit_Vector is

	function Evaluate(Evaluation : in Binary_Bit_Vector_Evaluation; Representation : in Representation_Access) return Float is
		r : Integer  := 0;
		b : Bit_Representation_Access;
		v : Vector_Representation_Access := Vector_Representation_Access(Representation);
	begin
		for i in reverse 1..Size(v) loop
			Get(v, i, b);
			if Get(b) then
				r := 2 * r + 1;
			else
				r := 2 * r;
			end if;
		end loop;
		return Float(r);
	end Evaluate;

end Mutants.Core.Evaluation.Binary_Bit_Vector;
