--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Individual componenet
--
-- Author  Matthew Caryl
-- Created 9.12.96
--

with Mutants.Core.Representation;
use Mutants.Core.Representation;

package body Mutants.Core.Individual is

	function Representation(Individual : in Individual) return Representation_Access is
	begin
		return Individual.Individual_Representation;
	end Representation;

	function Evaluation(Individual : in Individual) return Float is
	begin
		return Individual.Evaluation;
	end Evaluation;

	procedure Evaluation(Individual : in out Individual; Value : in Float) is
	begin
		Individual.Evaluation := Value;
	end Evaluation;

	function Representation(Individual : in Individual_Access) return Representation_Access is
	begin
		return Representation(Individual.all);
	end Representation;

	function Evaluation(Individual : in Individual_Access) return Float is
	begin
		return Evaluation(Individual.all);
	end Evaluation;

	procedure Evaluation(Individual : in Individual_Access; Value : in Float) is
	begin
		Evaluation(Individual.all, Value);
	end Evaluation;

	Current_ID : Long_Integer := 0;

	procedure Initialize(Individual : in out Individual) is
	begin
		Individual.Individual_Representation := new Mutants.Core.Representation.Representation'Class'(Individual.Individual_Representation.all);
		Individual.ID := Current_ID;
		Current_ID := Current_ID + 1;
	end Initialize;

	procedure Adjust(Individual : in out Individual) is
	begin
		Individual.Individual_Representation := new Mutants.Core.Representation.Representation'Class'(Individual.Individual_Representation.all);
	end Adjust;

	procedure Finalize(Individual : in out Individual) is
	begin
		null;
	end Finalize;

end Mutants.Core.Individual;
