--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Individual componenet
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

with Mutants.Core.Representation;
with Ada.Finalization;
use Mutants.Core.Representation;

package Mutants.Core.Individual is

	type Individual(Representation : Representation_Access) is private;

	function Representation(Individual : in Individual) return Representation_Access;
	function Evaluation(Individual : in Individual) return Float;
	procedure Evaluation(Individual : in out Individual; Value : in Float);

	type Individual_Access is access all Individual;

	function Representation(Individual : in Individual_Access) return Representation_Access;
	function Evaluation(Individual : in Individual_Access) return Float;
	procedure Evaluation(Individual : in Individual_Access; Value : in Float);

	type Individual_Access_Array is array(Integer range <>) of Individual_Access;
	type Individual_Access_Array_Access is access Individual_Access_Array;

private
	
	type Individual(Representation : Representation_Class_Access) is new Ada.Finalization.Controlled with
		record
			Individual_Representation : Representation_Access := Representation;
			Evaluation : Float := 0.0;
			ID : Long_Integer;
		end record;

	procedure Initialize(Individual : in out Individual);
	procedure Adjust(Individual : in out Individual);
	procedure Finalize(Individual : in out Individual);

end Mutants.Core.Individual;
