--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Random component
--
-- Author  Matthew Caryl
-- Created 10.12.96
--

package Mutants.Core.Random is
	type Random(Seed : Long_Integer := 1) is private;

	procedure Reset(Random : in out Random);
	procedure Reset(Random : in out Random; Seed : Long_Integer);

	type Random_Access is access all Random;

	function Value(Random : in Random_Access) return Boolean;
	function Value(Random : in Random_Access; Upper : in Integer) return Integer;
	function Value(Random : in Random_Access; Lower, Upper : in Integer) return Integer;
	function Value(Random : in Random_Access; Upper, Precision : in Integer) return Float;
	function Value(Random : in Random_Access; Lower, Upper, Precision : in Integer) return Float;

private

	type Random(Seed : Long_Integer := 1) is
		record
			Random_seed : Long_Integer := Seed;
		end record;

end Mutants.Core.Random;
