--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Core toolkit - Vector representation component
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

package body Mutants.Core.Representation.Vector is

	function Equal(one, two : Vector_Representation) return Boolean is
	begin
		if Size(one) /= Size(two) then
			return false;
		end if;
		for i in 1..Size(one) loop
			if Equal(one.Element_Vector(i), two.Element_Vector(i)) then
				return false;
			end if;
		end loop;
		return true;
	end Equal;
	
	function Get(Representation : in Vector_Representation; Index : Positive) return Element_Type is
	begin
		return Representation.Element_Vector(Index);
	end Get;

	procedure Set(Representation : in out Vector_Representation; Index : Positive; Element : in Element_Type) is
	begin
		Representation.Element_Vector(Index) := Element;
	end Set;

	function Size(Representation : in Vector_Representation) return Positive is
	begin
		return Representation.Element_Vector'Last;
	end Size;

	procedure Get(Representation : in out Vector_Representation; Index : Positive; Element : out Element_Type_Access) is
	begin
		Element := Representation.Element_Vector(Index)'Unchecked_Access;
	end Get;

	function Get(Representation : in Vector_Representation_Access; Index : Positive) return Element_Type is
	begin
		return Get(Representation.all, Index);
	end Get;

        procedure Set(Representation : in Vector_Representation_Access; Index : Positive; Element : in Element_Type) is
	begin
		Set(Representation.all, Index, Element);
	end Set;

	function Size(Representation : in Vector_Representation_Access) return Positive is
	begin
		return Size(Representation.all);
	end Size;

	procedure Get(Representation : in Vector_Representation_Access; Index : Positive; Element : out Element_Type_Access) is
	begin
		Get(Representation.all, Index, Element);
	end Get;

end Mutants.Core.Representation.Vector;
