--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Low Selector component
--
-- Author  Matthew Caryl
-- Created 6.2.97
--

with Mutants.Core.Selector;
with Mutants.Core.Individual;
use Mutants.Core.Selector;
use Mutants.Core.Individual;

package body Mutants.Core.Selector.Low is

        procedure Attach(Sel : in out Low_Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class) is
		fi : FitnessIterator'Class := Iterator(Fit);
		more : Boolean;
		i : Individual_Access;
		v : Float;
		low_i : Individual_Access;
		low_v : Float;
	begin
		Next(fi, more, low_i, low_v);
		if not more then
			raise Empty_Population_Exception;
		end if;
		while more loop
			Next(fi, more, i, v);
			if v < low_v then
				low_v := v;
				low_i := i;
			end if;
		end loop;
		Sel.Low_Individual := low_i;
	end Attach;

        procedure Get(Sel : in out Low_Selector; Individual : out Individual_Access) is
	begin
		Individual := Sel.Low_Individual;
	end Get;

        procedure Put(Sel : in out Low_Selector; Individual : in Individual_Access) is
	begin
		null;
	end Put;

end Mutants.Core.Selector.Low;
