--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Core Toolkit - Selector component
--
-- Author  Matthew Caryl
-- Created 19.12.96
--

with Mutants.Core.Fitness;
with Mutants.Core.Individual;
use Mutants.Core.Fitness;
use Mutants.Core.Individual;

package Mutants.Core.Selector is

	type Selector is abstract tagged private;
	subtype Selector_Class is Selector'Class;
	type Selector_Access is access all Selector'Class;
	Empty_Population_Exception : exception;

	procedure Attach(Sel : in out Selector; Fit : in out Mutants.Core.Fitness.Fitness'Class) is abstract;
	procedure Get(Sel : in out Selector; Individual : out Individual_Access) is abstract;
	procedure Put(Sel : in out Selector; Individual : in Individual_Access) is abstract;

private
	
	type Selector is abstract tagged null record;

end Mutants.Core.Selector;
