--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- Extended Toolkit - Order random reproduction component
--
-- Author  Matthew Caryl
-- Created 12.2.97
--
-- Unfinshed - need to include history varient

with Mutants.Core.Selector;
with Mutants.Core.Population;
with Mutants.Core.Representation.Order;
with Mutants.Core.Random;
with Mutants.Core.Creator;
use Mutants.Core.Selector;
use Mutants.Core.Representation;
use Mutants.Core.Random;

generic
	with package Order_Package is new Mutants.Core.Representation.Order(<>);

package Mutants.Extended.Creator.Order_Random_Reproduction is

	type Order_Random_Reproduction(Random : Random_Access) is new Mutants.Core.Creator.Creator with private;

	procedure Create(Creator : in out Order_Random_Reproduction; Pop : in out Mutants.Core.Population.Population; Size : in Natural);
	procedure Selector(Creator : in out Order_Random_Reproduction; Sel : Selector_Access; Required : out Boolean);
	
private
	
	type Order_Random_Reproduction(Random : Random_Access) is new Mutants.Core.Creator.Creator with
		record
			Selector : Selector_Access;
			Chance : Random_Access := Random;
		end record;
			
	function Parents(Creator : in Order_Random_Reproduction) return Natural;
	procedure Breed(Creator : in out Order_Random_Reproduction; Reps_In : in Representation_Access_Array; Rep_Out : out Representation_Access; Success : out Boolean);

end Mutants.Extended.Creator.Order_Random_Reproduction;
