--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- Test harness for representation
--
-- Author  Matthew Caryl
-- Created 11.12.96
--

with Ada.Text_IO.Enumeration_IO;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation.Bit_Vector;
use Ada.Text_IO;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation.Bit_Vector;

procedure RepresentationTest is
	package Boolean_IO is new Ada.Text_IO.Enumeration_IO(Boolean);

	b : Bit_Representation;
	v : Vector_Representation(10);
	ba : Bit_Representation_Access;
	
begin
	Boolean_IO.Put(Get(b));
	New_Line;
	Set(b, true);
	Boolean_IO.Put(Get(b));
	New_Line;
	Set(b, false);
	Boolean_IO.Put(Get(b));
	New_Line;

	New_Line;
	for i in 1..10 loop
		Boolean_IO.Put(Get(Get(v, i)));
		New_Line;
	end loop;

	New_Line;
	for i in 1..10 loop
		Get(v, i, ba);
		Set(ba, true);
		Boolean_IO.Put(Get(Get(v, i)));
		New_Line;
	end loop;
end RepresentationTest;
