--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- High selector component test
--
-- Author  Matthew Caryl
-- Created 20.12.96
--

with Mutants.Core.Individual;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation;
with Mutants.Core.Population;
with Mutants.Core.Fitness.Unity;
with Mutants.Core.Selector.High;
with Ada.Text_IO.Enumeration_IO;
with Ada.Text_IO.Float_IO;
use Mutants.Core.Individual;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation;
use Mutants.Core.Population;
use Mutants.Core.Fitness.Unity;
use Mutants.Core.Selector.High;
use Ada.Text_IO;

procedure SelectorTest is

	package Boolean_IO is new Ada.Text_IO.Enumeration_IO(Boolean);
	package Float_IO is new Ada.Text_IO.Float_IO(Float);

	b : Bit_Representation_Access;
	i : Individual_Access;
	p : aliased Population;
	f : Unity_Fitness;
	s : High_Selector;
	v : Float;
begin
	for n in 1..10 loop
		b := new Bit_Representation;
		if (n mod 2 = 0) then
			Set(b, true);
		else
			Set(b, false);
		end if;
		i := new Individual(Representation_Access(b));
		Evaluation(i, Float(n));
		Add(p, i);
	end loop;
	Attach(f, p'Unchecked_Access);
	Attach(s, f);

	Get(s, i);
	Boolean_IO.Put(Get(Bit_Representation_Access(Mutants.Core.Individual.Representation(i))));
	New_Line;
	Float_IO.Put(Evaluation(i));
	New_Line;

	b := new Bit_Representation;
	Set(b, false);
	i := new Individual(Representation_Access(b));
	Evaluation(i, 20.0);
	Add(p, i);
	Attach(f, p'Unchecked_Access);
	Attach(s, f);

	Get(s, i);
	Boolean_IO.Put(Get(Bit_Representation_Access(Mutants.Core.Individual.Representation(i))));
	New_Line;
	Float_IO.Put(Evaluation(i));
end SelectorTest;
