--
-- MUTANTS : a generic genetic algorithm toolkit for Ada 95
--
-- test one point vector crossover
--
-- Author  Matthew Caryl
-- Created 22.1.96
--

with Mutants.Core.Random;
with Mutants.Core.Ending.Count;
with Mutants.Core.Representation.Bit;
with Mutants.Core.Representation.Bit_Vector;
with Mutants.Core.Evaluation.Binary_Bit_Vector;
with Mutants.Core.Individual;
with Mutants.Core.Population;
with Mutants.Core.Fitness.Unity;
with Mutants.Core.Selector.High;
with Mutants.Core.Selector.Roulette;
with Mutants.Core.Creator.Bit_Random_Initialise;
with Mutants.Core.Creator.Bit_Mutation_Reproduction;
with Mutants.Core.Creator.Vector_Bit_Random_Initialise;
with Mutants.Core.Creator.Single_Bit_Vector_Reproduction;
with Mutants.Core.Creator.Bit_Onepoint_Vector_Crossover_Reproduction;
with Mutants.Core.Model.Generation;
with Ada.Text_IO;
use Mutants.Core.Random;
use Mutants.Core.Ending.Count;
use Mutants.Core.Representation.Bit;
use Mutants.Core.Representation.Bit_Vector;
use Mutants.Core.Evaluation.Binary_Bit_Vector;
use Mutants.Core.Individual;
use Mutants.Core.Population;
use Mutants.Core.Fitness.Unity;
use Mutants.Core.Selector.High;
use Mutants.Core.Selector.Roulette;
use Mutants.Core.Creator.Bit_Random_Initialise;
use Mutants.Core.Creator.Bit_Mutation_Reproduction;
use Mutants.Core.Creator.Vector_Bit_Random_Initialise;
use Mutants.Core.Creator.Single_Bit_Vector_Reproduction;
use Mutants.Core.Creator.Bit_Onepoint_Vector_Crossover_Reproduction;
use Mutants.Core.Model.Generation;
use Ada.Text_IO;

procedure Test3 is

	procedure Print(population : Population_Access) is
		iter : PopulationIterator := Iterator(population);
		more : Boolean;
		individual : Individual_Access;
		bit_vector : Vector_Representation_Access;
		bit : Bit_Representation_Access;
	begin
		Next(iter, more, individual);
		while more loop
			bit_vector := Vector_Representation_Access(Representation(individual));
			for i in reverse 1..Size(bit_vector) loop
				Get(bit_vector, i, bit);
				if Get(bit) then
					Put("1");
				else
					Put("0");
				end if;
			end loop;
			New_Line;
			Next(iter, more, individual);
		end loop;
	end Print;
	
	size : Natural := 10;
	rand : aliased Random;
	bit_initialiser : aliased Bit_Random_Initialise(rand'Unchecked_Access);
	initialiser : aliased Vector_Initialise(bit_initialiser'Unchecked_Access, 8);
	model : Generation_Model(initialiser'Unchecked_Access, size);
	evaluator : Binary_Bit_Vector_Evaluation;
	fitness : Unity_Fitness;
	selector : Roulette_Selector(rand'Unchecked_Access);
	reproduction : Onepoint_Vector_Crossover_Reproduction(rand'Unchecked_Access);
	ending : Count_Ending;
	population : Population_Access;
begin
	Reset(ending, 10);
	Get_Population(model, population);
	Put_Line("Population before");
	Print(population);
	Run(model, evaluator, fitness, selector, reproduction, ending);
	Get_Population(model, population);
	Put_Line("Population after");
	Print(population);
end Test3;
