--
-- MUTANTS : A generic genetic algorithm toolkit for Ada 95
--
-- TSP Evaluation component
--
-- Author  Matthew Caryl
-- Created 4.2.97
--

with Mutants.Core.Evaluation;
with Mutants.Core.Representation;
use Mutants.Core.Evaluation;
use Mutants.Core.Representation;

package TSP_Evaluation is

	type TSP_Evaluation(size : Integer) is new Mutants.Core.Evaluation.Evaluation with private;

	function Evaluate(Evaluation : in TSP_Evaluation; Representation : in Representation_Access) return Float;

	procedure Put(Evaluation : in out TSP_Evaluation; Value : Float; X, Y : Integer);
	function Get(Evaluation : in TSP_Evaluation; X, Y : Integer) return Float;
	function Size(Evaluation : in TSP_Evaluation) return Integer;

private

	type Matrix_Array is array (Integer range <>, Integer range <>) of Float;

	type TSP_Evaluation(size : Integer) is new Mutants.Core.Evaluation.Evaluation with 
		record
			matrix : Matrix_Array(1..size, 1..size);
		end record;

end TSP_Evaluation;
