-- A matrix object
--
-- Author	Matthew Caryl
-- Created	18.11.96

package Matrix is
	type Matrix(width, height : Integer) is private;
	type Matrix_Access is access Matrix;
	
	procedure Put(matrix : in out Matrix; value : Float; x, y : Integer);
	function Get(matrix : in Matrix; x, y : Integer) return Float;
	function Width(matrix : in Matrix) return Integer;
	function Height(matrix : in Matrix) return Integer;
private
	type Matrix_Array is array (Integer range <>, Integer range <>) of Float;
	type Matrix(width, height : Integer) is
		record
			matrix : Matrix_Array(1..width , 1..height);
		end record;
end Matrix;
